<?php
/*
 * $Revision: 1.4 $
 *
 * $RCSfile: MapGxMagnifierAdmin.inc
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @version 0.5.1a
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 */

GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
GalleryCoreApi::requireOnce('modules/map/classes/GoogleMapUtilities.class');

/**
 * @package map
 * @subpackage UserInterface
 */
class MapGxMagnifierAdminController extends GalleryController {
    /**
     * @see GalleryController::handleRequest
     */
    function handleRequest($form) {

        include(dirname(__FILE__).'/includes/MapAdminControllerInit.inc');

        //Cancel hit, return to the default GxMagnifier Admin Page
        if (isset($form['action']['cancel'])) {

            $results['status'] = $status;
            $results['error'] = array ();
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapGxMagnifierAdmin';
        }

        // Save the GxMagnifier settings
        if (isset($form['action']['save'])) {
               //error checking
               if (!array_key_exists('GxPos', $form)) {
                 $form['GxPos'] = "0";
               }elseif (!array_key_exists('GxSize', $form)){
                 $form['GxSize'] = "Default";
               }elseif (!array_key_exists('GxZoom', $form)){
                 $form['GxZoom'] = "Default";
               }elseif (($form['GxZoom']!="Default") and ((!array_key_exists('GxZoomNum', $form)) || ($form['GxZoomNum'] == "") || (!is_numeric($form['GxZoomNum'])))) {
                 $error[] = 'form[error][noGxZoom]';
               }elseif (($form['GxSize']!="Default") and (($form['GxSizeY'] == "") or ($form['GxSizeX'] == "") or (!is_numeric($form['GxSizeY'])) or (!is_numeric($form['GxSizeX'])))) {
                 $error[] = 'form[error][noGxSize]';
               }elseif (!array_key_exists('Gx2Pos', $form)) {
                 $form['Gx2Pos'] = "3";
//This checks that the Zoom chosen for the docked GxMagnifier is correct, disabled for the time being
//               }elseif ((!array_key_exists('Gx2ZoomNum', $form)) || ($form['Gx2ZoomNum'] == "") || (!is_numeric($form['Gx2ZoomNum']))) {
//                 $error[] = 'form[error][noGx2Zoom]';
               }elseif (($form['Gx2SizeY'] == "") || ($form['Gx2SizeX'] == "") || (!is_numeric($form['Gx2SizeY'])) || (!is_numeric($form['Gx2SizeX']))) {
                 $error[] = 'form[error][noGx2Size]';
               }elseif ($form['Gx2PosOffY'] == "") {
                 $form['Gx2PosOffY'] ="0";
               }elseif ($form['Gx2PosOffX'] == ""){
                 $form['Gx2PosOffX'] ="0";
               }else{

               if(!array_key_exists('GxZoomNum', $form))            $form['GxZoomNum']="";
               else $form['GxZoomNum'] = round($form['GxZoomNum']);
               if(!array_key_exists('Gx2ZoomNum', $form))            $form['Gx2ZoomNum']="";
               else $form['Gx2ZoomNum'] = round($form['Gx2ZoomNum']);
               if(!array_key_exists('GxSizeX', $form))              $form['GxSizeX']="";
               if(!array_key_exists('GxSizeY', $form))              $form['GxSizeY']="";


                foreach (array('GxZoom','GxZoomNum','GxSize','GxSizeX','GxSizeY','GxPos','Gx2Pos','Gx2ZoomNum','Gx2SizeX','Gx2SizeY','Gx2Type','Gx2PosOffX','Gx2PosOffY') as $setting) {
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting, $form[$setting]);
                }

                foreach (array('GxMagnifier','GxAutoPan','GxMagnifier2','Gx2Content') as $setting) {
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting,
                        (isset($form[$setting]) && $form[$setting]) ? 1 : 0);
                }

                $status['saved'] = 1;
               }

            // Figure out the method we will use
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapGxMagnifierAdmin';
            $results[$method]['mode'] = 'Magnify';
            }

        return array (null, $results);
    }
}

/**
 * @package map
 * @subpackage UserInterface
 */
class MapGxMagnifierAdminView extends GalleryView {
    /**
     * @see GalleryView::loadTemplate
     */
    function loadTemplate(&$template, &$form) {

        include(dirname(__FILE__).'/includes/MapAdminViewInit.inc');
        $form['formName'] = 'MapGxMagnifierAdmin';
        $template->head('modules/map/includes/GoogleMap.css');
        $template->javascript('modules/map/GoogleMap.js');

        if(!array_key_exists('GxMagnifier', $form))          $form['GxMagnifier']=false;
        if(!array_key_exists('GxMagnifierPath', $form))      $form['GxMagnifierPath']=$base."modules/map/GxMagnifier/";
        if(!array_key_exists('GxZoom', $form))               $form['GxZoom']="Default";
        if(!array_key_exists('GxZoomNum', $form))            $form['GxZoomNum']="2";
        if(!array_key_exists('GxSize', $form))               $form['GxSize']="Default";
        if(!array_key_exists('GxSizeX', $form))              $form['GxSizeX']="100";
        if(!array_key_exists('GxSizeY', $form))              $form['GxSizeY']="100";
        if(!array_key_exists('GxPos', $form))                $form['GxPos']="0";
        if(!array_key_exists('GxAutoPan', $form))            $form['GxAutoPan']=false;
        if(!array_key_exists('GxMagnifier2', $form))         $form['GxMagnifier2']=false;
        if(!array_key_exists('Gx2Content', $form))           $form['Gx2Content']=false;
        if(!array_key_exists('Gx2ZoomNum', $form))           $form['Gx2ZoomNum']="-5";
        if(!array_key_exists('Gx2SizeX', $form))             $form['Gx2SizeX']="200";
        if(!array_key_exists('Gx2SizeY', $form))             $form['Gx2SizeY']="200";
        if(!array_key_exists('Gx2Pos', $form))               $form['Gx2Pos']="3";
        if(!array_key_exists('Gx2PosOffX', $form))           $form['Gx2PosOffX']="0";
        if(!array_key_exists('Gx2PosOffY', $form))           $form['Gx2PosOffY']="0";
        if(!array_key_exists('Gx2Type', $form))              $form['Gx2Type']="G_SATELLITE_TYPE";

        include(dirname(__FILE__).'/includes/MapAdminEdits.inc');

  	if ($template->hasVariable('SiteAdmin')) {
  	    $SiteAdmin =& $template->getVariableByReference('SiteAdmin');
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	} else {
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	    $template->setVariable('SiteAdmin', $SiteAdmin);
  	}

          $template->setVariable('controller', 'map.MapGxMagnifierAdmin');
  	return array(null,
  		     array('body' => 'modules/map/templates/MapGxMagnifierAdmin.tpl'));
      }
}

?>